package AttachImage;
use strict;
use vars qw($VERSION);
$VERSION = 0.1;

sub new {
	my $class = shift;
	my $self = {};
	return bless $self,$class;
}

sub get_file_list {
	my $wiki = shift;
	my $page = shift;
	my $encode_page = &Util::url_encode($page);
	my @list;
	if(-e $wiki->config('image_dir')){
		opendir(DIR,$wiki->config('image_dir')) or die $!;
		while(my $entry = readdir(DIR)){
			if(index($entry,$encode_page.".")==0){
				my $file = $entry;
				$file =~ s|[^\.]+.||;
				push(@list,&Util::url_decode($file));
			}
		}
		closedir(DIR);
	}
	@list = sort { $a cmp $b } @list;
	return @list;
}

sub create_filename {
	my $wiki = shift;
	my $page = shift;
	my $file = shift;
	
	return $wiki->config('image_dir')."/".&Util::url_encode($page).".".&image_url_encode($file);
}

sub image_url_encode {
	my $retstr = shift;
	$retstr =~ s/([^.^ 0-9A-Za-z])/sprintf("%%%.2X", ord($1))/eg;
	$retstr =~ tr/ /+/;
	return $retstr;
}

1;
