############################################################
#
# ALPSLAB ؤTrackBackPingΥϥɥ顣
#
# Written by OHTSUKA Ko-hei<nene@kokogiko.net>
#
# Version 0.1 (2006.03.05)
#
############################################################
package plugin::alpsmap::SendPingHandler;

use strict;

use vars qw($VERSION);
$VERSION = "0.1";
my $USER_AGENT = "FreeStyleWiki AlpsLAB TrackBackPingPlugin $VERSION";

#顼
sub STATUS_OK {1};
sub STATUS_HTTP_ERR {2};
sub STATUS_PING_ERR {3};
sub STATUS_NO_TRACKBACK_RESPONSE {4};

#===========================================================
# 󥹥ȥ饯
#===========================================================
sub new {
	my $class = shift;
	my $self = {};
	return bless $self,$class;
}

#===========================================================
# ping
#===========================================================
sub do_action {

	my $self = shift;
	my $wiki = shift;
	my $cgi  = $wiki->get_CGI;

	my $mode;
	my %data;					#ѥ᡼ݻϥå
	my $msg;					#åݻ
	my $res;					#HTTP쥹ݥݻ

	#---------------------------------
	# եɤ߹
	#---------------------------------
	&plugin::trackback::TrackBackUtil::load_config($self, $wiki);

	#---------------------------------
	# pingѥǡΥå
	#---------------------------------

	#֥̾
	$data{'blog_name'} = &Util::url_decode($wiki->config('site_title'));

	#ڡ̾
	$data{'title'} = &Util::url_decode($cgi->param('page'));

	#ڡURL
	$data{'url'} = $self->_get_trackback_gate_url($wiki, $wiki->get_CGI()->url, $data{'title'});

	#
	$data{'excerpt'} = &Util::url_decode($cgi->param('excerpt'));

	#Pingڡ̾
	$data{'page'} = $data{'title'};

	#Ping襢ɥ쥹/а
	$data{'pos'} = &Util::url_decode($cgi->param('pos'));

	#PINGơ
	$data{'status'} = 0;

	#顼å
	$data{'message'} = '';

	#HTTP쥹ݥ
	$data{'response'} = '';

	#---------------------------------
	# 顼å
	#---------------------------------
	$res = $self->_check_parameter(\%data, 1);		#õѥ顼å
	if ($res) {
		#顼Ȥˤϡ顼ڡФ
		return $wiki->error($res);
	}

	#---------------------------------
	# ping
	#---------------------------------
	$self->send_ping($wiki, \%data);

	if ($data{'status'} == STATUS_OK){
		#ϤȤΥڡإ쥯
		$wiki->redirect($data{'page'});

	}elsif($data{'status'} == STATUS_HTTP_ERR){
		#HTTP顼HTTP顼ɤɽ
		return $wiki->error('ERROR! ' . $data{'message'});

	}elsif($data{'status'} == STATUS_PING_ERR){
		#PING顼ϥ顼åɽ
		return $wiki->error('ERROR! ' . $data{'message'});

	}else{
		#Ȥϥå
		return $wiki->error('ERROR! ʥ顼Ǥ');
	}
}


#===========================================================
# ping
#===========================================================
sub send_ping {

	my $self = shift;
	my $wiki = shift;
	my $ref_data = shift;		#ϥåΥե

	my %data;					#ѥ᡼ݻϥå
	my $msg;					#顼åݻ
	my $res;					#HTTP쥹ݥݻ

	#---------------------------------
	# 顼å
	#---------------------------------
	$res = $self->_check_parameter($ref_data, 0);
	if ($res) {
		#顼Ȥˤϡ顼ڡФ
		return $wiki->error($res);
	}

	#---------------------------------
	# μ
	#---------------------------------
	$$ref_data{'excerpt'} = $self->_get_excerpt($wiki, $$ref_data{'excerpt'});

	#---------------------------------
	# PING
	#---------------------------------
	$self->_send_ping($ref_data);

	return;

}

#===========================================================
# 顼å
#===========================================================
sub _check_parameter{

	my $self = shift;
	my $ref_data = shift;			#ϥåΥե
	my $mode = shift;				#顼å⡼(0:̾1:õ)

	if($mode == 1){return ''}	#õϤǥåλ

	if($$ref_data{'blog_name'} eq ''){ return 'wiki̾Ǥޤ'; }
	if($$ref_data{'title'} eq ''){ return 'ڡ̾Ǥޤ'; }

	return '';
}

sub to_msec{
	my $r = 0;
	my @tmp = split(/\//,shift);
	for(my $i=0;$i<@tmp;$i++){
		$r += $tmp[$i]/(60.0**$i);
	}
	int($r*3600000.0);
}

#===========================================================
# TrackBackPing
#===========================================================
sub _send_ping {

	use LWP::UserAgent;

	my $self = shift;
	my $ref_data = shift;
	my %prm;
	my $url = 'http://base.alpslab.jp/bin/tb';
	my $content = '';

	my $ua = LWP::UserAgent->new;
	$ua->agent($USER_AGENT);

	#------------------------------------------------------------------
	# ʸɤѴ
	#------------------------------------------------------------------
	my $title = $$ref_data{'title'};
	my $excerpt = $$ref_data{'excerpt'};
	my $blog_name = $$ref_data{'blog_name'};
	my $pos = $$ref_data{'pos'};

	Jcode::convert( \$title, 'euc-jp');
	Jcode::convert( \$excerpt, 'euc-jp');
	Jcode::convert( \$blog_name, 'euc-jp');
	Jcode::convert( \$pos, 'euc-jp');

	my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	$content = "date=" . &Util::url_encode(sprintf("%d-%d-%d %d:%d:%d",($year+1900,$mon+1,$mday,$hour,$min,$sec))) . "&";

	if ( $pos =~ /[^0-9\-\.\,\/]/ ) {
		$content .= "address=" . &Util::url_encode($pos) . "&";
	} else {
		my ($lat,$lon) = split(/\,/,$pos);
		$url .= "/".&to_msec($lat)."/".&to_msec($lon);
	}

	#------------------------------------------------------------------
	# ping
	#  &иȤʸڤƤޤΤ
	#------------------------------------------------------------------
	my $req = HTTP::Request->new(POST => $url);
	$req->content_type('application/x-www-form-urlencoded');
	$content .= "title=" . &Util::url_encode($title)
		.	"&url=" . &Util::url_encode($$ref_data{'url'})
		.	"&excerpt=" . &Util::url_encode($excerpt)
		.	"&blog_name=" . &Util::url_encode($blog_name)
		.	"&charset=EUC-JP";

	open SD,">/home/htdocs/kokogiko/tbtest.txt";
	print SD "$pos\n$content\n";
	close SD;

	$req->content($content);

	#
	my $res = $ua->request($req);

	use Data::Dumper;
	open SD,">>/home/htdocs/kokogiko/tbtest.txt";
	print SD Dumper($res);
	close SD;

	if(!$res->is_success){
		$$ref_data{'status'} = STATUS_HTTP_ERR;
		$$ref_data{'message'} = $res->status_line;
		$$ref_data{'response'} = '';
		return;
	}

	#Υ쥹ݥ󥹤֤äƤƤ뤫ɤå
	if ($res->content =~ m!<response>.*<error>(\d+).*</error>.*</response>!s){
		#顼åäƤ⡢ơ顼̵ФΤޤޥ쥯Ȥ
		my($e, $msg) = $res->content =~ m!<error>(\d+).*<message>(.+?)</message>!s;
		if ($e){
			$$ref_data{'status'} = STATUS_PING_ERR;
			$$ref_data{'message'} = $msg;
			$$ref_data{'response'} = '';
		}else{
			$$ref_data{'status'} = STATUS_OK;
			$$ref_data{'message'} = '';
			$$ref_data{'response'} = '';
		}
	}else{
		$$ref_data{'status'} = STATUS_NO_TRACKBACK_RESPONSE;
		$$ref_data{'message'} = '۾ʥȥåХåα֤äƤޤ';
		$$ref_data{'response'} = $res->content;
	}

	return;

}

#===========================================================
# ڡʸȴФ
#===========================================================
sub _get_excerpt_from_content {

	use plugin::trackback::TrackBackUtil;

	my $self = shift;
	my $page_body = shift;

	# ץ饰
	$page_body =~ s/{{((.|\s)+?)}}//g;
	# Ǥä
	$page_body =~ s/(==)(.+?)(==)/$2/g;
	# ܡɤ
	$page_body =~ s/(''')(.+?)(''')/$2/g;
	# å
	$page_body =~ s/('')(.+?)('')/$2/g;
	# ̾󥯤
	$page_body =~ s/\[([^\[]+?)\|((http|https|ftp|mailto):[a-zA-Z0-9\.,%~^_+\-%\/\?\(\)!\$&=:;\*#\@']*)\]/$1/g;
	$page_body =~ s/\[([^\[]+?)\|(file:[^\[\]]*)\]/$1/g;
	$page_body =~ s/\[([^\[]+?)\|((\/|\.\/|\.\.\/)+[a-zA-Z0-9\.,%~^_+\-%\/\?\(\)!\$&=:;\*#\@']*)\]/$1/g;
	# ڡ̾󥯤
	$page_body =~ s/\[\[([^\[]+?)\|(.+?)\]\]/$1/g;
	# ڡ󥯤
	$page_body =~ s/\[\[([^\[]+?)\]\]/$1/g;
	# 
	$page_body =~ s/(__)(.+?)(__)/$2/g;
	# 顼å
	$page_body =~ s/(<<)(.+?)(>>)/$2/g;

	# PRE
	$page_body =~ s/^(\s|\t)//mg;
	# Ф
	$page_body =~ s/^!{1,3}//mg;
	# 
	$page_body =~ s/^\*{1,3}//mg;
	# ֹդ
	$page_body =~ s/^\+{1,3}//mg;
	# ʿ
	$page_body =~ s/^-{4}$//mg;
	# 
	$page_body =~ s/^""//mg;

	# Ԥ
	$page_body =~ s/\n//g;

	#ƬʸʬڤФ
	return &plugin::trackback::TrackBackUtil::cut_by_bytelength($page_body
				,&plugin::trackback::TrackBackUtil::get_excerpt_length($self));

}

#===========================================================
# ȥåХåѤURL
#===========================================================
sub _get_trackback_gate_url{

	my $self = shift;
	my $wiki = shift;
	my $scripturl = shift;
	my $pagename = shift;

	#----------------------------------------------------------------------
	# ȥåХåѤURL
	#
	#	ȥåХåȤϡFreeStyleWikiܸ򤸤URL
	#	ѤȤˡפǤʤȤ򤹤뤿Υڡ
	#
	#	URL󥳡ɤ򤷤URLϤƤ⡢갷¦Υץǰۤ
	#	ʸɾǤ˥ǥɤƤޤȡ򤱤褦̵Τǡ
	#	褦ʿ̵ۤȼεˡˤURLϤ
	#
	#----------------------------------------------------------------------
	# ʳǤϥפʤ!!
	my $path_info = $wiki->get_CGI()->path_info();
	if(length($path_info)>0){		#Farmк
		$scripturl .= $path_info;
	}
	return $scripturl . '?action=TRACKBACKGATE&id='
				. &plugin::trackback::TrackBackUtil::get_trackback_id_from_pagename($pagename);
}

#===========================================================
# ȴФ
#===========================================================
sub _get_excerpt {

	use Util;
	use plugin::trackback::TrackBackUtil;

	my $self = shift;
	my $wiki = shift;
	my $excerpt = shift;

	#---------------------------------
	# ʸ
	#---------------------------------
	# Ԥ
	$excerpt =~ s/\r\n//g;
	$excerpt =~ s/\n//g;
	$excerpt =~ s/\r//g;

	# ȥ
	$excerpt = &Util::trim($excerpt);

	#ʸϤλ̵꤬ΤߡʸƬȴФ
	if ($excerpt eq ''){
		$excerpt = $self->_get_excerpt_from_content(
						$wiki->get_page(&Util::url_decode($wiki->get_CGI->param('page'))));
	}

	# ʸϤڤͤ
	$excerpt = &plugin::trackback::TrackBackUtil::cut_by_bytelength($excerpt
					,&plugin::trackback::TrackBackUtil::get_excerpt_length($self));

	return &Util::escapeHTML($excerpt);

}

;;;1;;;

